<div class="group-map" ...attributes>
  <div class="attributes-position" {{did-insert this.setup}} {{did-update this.updateCenter @position @position.center}} {{did-update this.checkEditMode @details}}>
    <div class="map-container {{if this.editMode 'fullscreen' 'view-mode'}}">
      <Map::Plain @disabled={{not this.editMode}} @onReady={{this.mapSetup}} as |map|>
        <Map::View @map={{map}} @extentM={{this.mapExtent}} @centerM={{this.position.coordinates}} @onChangeCenter={{fn this.updatePosition map}} />

        <Map::Interaction::DoubleClickZoom @map={{map}} @duration={{150}} @delta={{1}} />
        <Map::Layer::Base @map={{map}} @value={{this.selectedBaseMap}} @onSetupError={{this.layerSetupError}} />

        {{#if this.editMode}}
          {{#if @extent}}
            <Map::Layer::Vector @style={{this.extentStyle}} @map={{map}} as |vector source|>
              <Map::Features::Geojson::Polygon @source={{source}} @value={{@extent}} />
            </Map::Layer::Vector>

            <Map::Layer::Overlay @map={{map}} @position={{this.extentLabelPosition}} @positioning="bottom-center" class="map-extent-name">
              {{@extentName}}
            </Map::Layer::Overlay>
          {{/if}}

          {{#if this.markerMessage}}
            <Map::MapCenterMarker @message={{t this.markerMessage}} />
          {{/if}}

          <Map::Container @left={{true}} @top={{true}}>
            <Input::Search @onSearch={{this.search}} @hasResults={{@searchResults}}>
              {{#each @searchResults as |result|}}
                <button type="button" class="list-group-item list-group-item-action" aria-current="true" {{on "click" (fn this.selectResult result)}}>
                  {{result.name}}
                </button>
              {{/each}}
            </Input::Search>
          </Map::Container>

          <Map::Container @right={{true}} @top={{true}}>
            <button class="btn btn-secondary btn-dismiss" type="button" {{on "click" this.dismiss}}>
              <FaIcon @icon="times" />
            </button>
          </Map::Container>

          <Map::Container @left={{true}} @bottom={{true}}>
            <button class="btn btn-primary btn-submit btn-submit-location" type="button" {{on "click" this.confirm}}>
              {{capitalize (t "save the pin location")}}
            </button>
          </Map::Container>

          <Map::Container @right={{true}} @bottom={{true}}>
            <Map::Controls @localizationEnabled={{not this.position.isError}} @onLocalize={{this.localize}} @map={{map}} />
            <Map::BaseMapSelect @list={{this.baseMaps}} @selected={{this.selectedBaseMap}} @onSelect={{this.selectBaseMap}} />
          </Map::Container>
        {{else if this.hasValidPosition}}
          {{#if (eq this.details.type "gps")}}
            <Map::Layer::UserPosition @map={{map}} @position={{@position.coordinates}} @accuracy={{this.position.accuracy}} />
          {{else}}
            <Map::Layer::Overlay @map={{map}} @position={{@position.coordinates}} @positioning="bottom-center" class="map-marker ol-point">
              <FaIcon @icon="map-marker-alt" @size="3x" />
            </Map::Layer::Overlay>
          {{/if}}
        {{/if}}
      </Map::Plain>

      {{#unless this.editMode}}
        {{!-- template-lint-disable no-invalid-interactive --}}
        <div {{on "click" this.edit}} class="picker-options d-flex justify-content-around align-content-center flex-column">
          <div class="m-auto">
            {{t "pick a location on the map"}}
          </div>
        </div>
      {{/unless}}
    </div>

    <div class="py-2">
      {{#if this.outsideExtent}}
        <div class="alert alert-warning alert-outside-extent" role="alert">
          {{t "survey-point-outside-extent"}}
        </div>
      {{/if}}
      <p>
        {{t "message-not-right-location"}}
      </p>
      <button class="btn btn-outline-primary btn-edit p-2" type="button" {{on "click" this.edit}}>
        <FaIcon @icon="pen" class="px-1" />
        {{t "pick it on the map"}}
      </button>
    </div>
  </div>
</div>